<template>
  <VContainer
    fluid
    fill-height
  >
    <VDataTable
      :headers="headers"
      :items="data"
      class="elevation-1 w-100"
    >
      <template v-slot:items="props">
        <td>{{ props.item.id }}</td>
        <td>{{ props.item.name }}</td>
        <td class="text-xs-right">
          {{ props.item.cpf | cpf }}
        </td>
        <td class="justify-center layout px-0">
          <VBtn
            icon
            @click="edit(props.item.id, props.index)"
          >
            <VIcon>edit</VIcon>
          </VBtn>
          <VBtn
            icon
            @click="del(props.item.id, props.index)"
          >
            <VIcon>delete</VIcon>
          </VBtn>
        </td>
      </template>
    </VDataTable>

    <VDialog
      v-model="dialog"
      :max-width="500"
      persistent
    >
      <VCard>
        <VForm
          ref="form"
          class="v-card__text"
        >
          <VTextField
            v-model="form.name"
            :rules="[
              v => !!v || 'Campo Obrigatório'
            ]"
            label="Nome completo"
          />
          <VTextField
            v-model="form.cpf"
            :rules="[
              v => !!v || 'Campo Obrigatório',
              v => (v && v.length >= 11) || 'CPF deve ter menos 11 caracteres'
            ]"
            label="CPF"
            mask="###.###.###-##"
          />
        </VForm>
        <VCardActions>
          <VSpacer />
          <VBtn
            flat
            @click="dialog = false; $refs.form.reset()"
          >
            Cancelar
          </VBtn>
          <VBtn
            color="primary"
            flat
            @click="submit"
          >
            Salvar
          </VBtn>
        </VCardActions>
      </VCard>
    </VDialog>
  </VContainer>
</template>

<script lang="ts">
import {
  Component, Vue, State, Mutation,
} from 'nuxt-property-decorator';

@Component({
  async asyncData({ $axios, error }) {
    try {
      const { data } = await $axios.get('/grower');
      return { data };
    } catch (e) {
      return error(e);
    }
  },

  filters: {
    cpf(val: string, type: string) {
      if (!val) return '';
      return val.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/, '$1.$2.$3-$4');
    },
  },
})
export default class Index extends Vue {
  @State
  modal!: boolean

  @Mutation
  setMsg!: (key: Object) => void

  @Mutation
  setModal!: (bool: boolean) => void

  data: Object[] = []

  headers = [
    {
      text: 'ID',
      value: 'id',
    },
    {
      text: 'Nome',
      value: 'name',
    },
    {
      text: 'CPF',
      value: 'cpf',
      align: 'right',
    },
    {
      text: 'Ações',
      align: 'center',
      sortable: false,
    },
  ]

  required = [(v: string) => !!v || 'Campo Obrigatório']

  form = {
    name: '',
    cpf: '',
  }

  update = {
    id: null,
    key: 0,
  };

  get dialog() {
    return this.modal;
  }

  set dialog(bool: boolean) {
    this.setModal(bool);
  }

  async edit(id: number, key: number) {
    try {
      const { data } = await this.$axios.get(`/grower/${id}`);

      this.form = {
        name: data.name,
        cpf: data.cpf,
      };
      this.update = {
        id: data.id,
        key,
      };
      this.dialog = true;
    } catch ({ message }) {
      this.setMsg({
        bool: true,
        color: 'error',
        message,
      });
    }
  }

  async submit() {
    try {
      if ((this.$refs.form as any).validate()) {
        const { data, status } = (this.update.id === null)
          ? await this.$axios.post('/grower', this.form)
          : await this.$axios.put(`/grower/${this.update.id}`, this.form);

        if ([200, 201].includes(status)) {
          this.setMsg({
            bool: true,
            color: 'success',
            message: `${status === 200 ? 'Atualizado' : 'Cadastrado'} com sucesso!`,
          });

          if (status === 201) this.data.push(data);
          else {
            this.$set(this.data, this.update.key, data);
            this.update.id = null;
          }

          this.dialog = false;
          (this.$refs.form as any).reset();
        } else {
          this.setMsg({
            bool: true,
            color: 'error',
            message: 'Erro ao cadastrar o nome no sistema, por favor tente novamente.',
          });
        }
      } else {
        this.setMsg({
          bool: true,
          color: 'error',
          message: 'Campos obrigatórios devem ser validados, tente novamente.',
        });
      }
    } catch ({ message }) {
      this.setMsg({
        bool: true,
        color: 'error',
        message,
      });
    }
  }

  async del(id: number, key: number) {
    try {
      const { status } = await this.$axios.delete(`/grower/${id}`);

      if (status === 200) {
        this.$delete(this.data, key);

        this.setMsg({
          bool: true,
          color: 'success',
          message: 'Deletado com sucesso!',
        });
      } else {
        this.setMsg({
          bool: true,
          color: 'error',
          message: 'Não foi possível deletar o dado, por favor tente novamente.',
        });
      }
    } catch ({ message }) {
      this.setMsg({
        bool: true,
        color: 'error',
        message,
      });
    }
  }
}
</script>

<style lang="stylus">
.w-100
  display flex
  flex-direction column
  width 100%
</style>
